Subject: [Pals] ELI/EL for the PW

From: "Shah, Himanshu" <[email-masked]>
Date: Tue, 14 Nov 2017 03:30:13 +0000

The PALS WG discussions yesterday at the IETF100, we discussed the competing
FAT PW and ELI/EL for the PW and its fate at S-PE.

I mentioned this at Mike but got lost in subsequent discussions.

FAT PW label as well as ELI/EL for PW (based on microflow within PW) resides
below PW label. Thus, @ingress PE, once microflow is identified, either ELI/EL
or FAT PW label is pushed.

@S-PE, PW label swap does not have to preserve the ELI/EL while doing PW label swapping,
BECAUSE it is already below the PW label, just like how FAT PW label would be.

I confirmed this from our data plane engineer.
(we can check with Kireeti as well)

I would like to know if other vendors are doing this differently??

Given this is true, for the switches that do DPI past PW control word for ECMP,

  *   FAT PW label would suffer the same misordering as no FAT PW label
  *   However, ELI/EL would NOT – because of the presence of ELI

Thanks,
Himanshu

---

From: Alexander Vainshtein <[email-masked]>
Date: Tue, 14 Nov 2017 12:14:24 +0000

Himamshu and all,
I respetfully disagree.

As I see it, RFC 6790 in Section 4.2 Ingress LSR" inambiguously states that EL and ELI, if used, between thr TL and "application label" (if spplication lsbel is used). It also specifies, that EL and ELI are only pushed on an incoming packet if the tunnel egress LSR has signaled that it can handle EL on the specific tunnel LSP it terminates.

To me this means that in the case of a MS-PW, EL and ELI CANNOT preserved by an S-PE. Whether they can be generated by an SPE is another story.

FAT labels, on the contrary, are always the BoS labels and thrrfore are preserved by SPEs of a MS-PW.

Did I miss something substantial?

Thump typed by Sasha Vainshtein

________________________________
From: Pals <[email-masked]> on behalf of Shah, Himanshu <[email-masked]>
Sent: Tuesday, November 14, 2017 5:30:13 AM
To: [email-masked]
Subject: [Pals] ELI/EL for the PW

Thanks,
Himanshu

___________________________________________________________________________

This e-mail message is intended for the recipient only and contains information which is 
CONFIDENTIAL and which may be proprietary to ECI Telecom. If you have received this 
transmission in error, please inform us by e-mail, phone or fax, and then delete the original 
and all copies thereof.
___________________________________________________________________________

---

From: "Shah, Himanshu" <[email-masked]>
Date: Wed, 15 Nov 2017 01:24:54 +0000

Hi Shasha,

You are correct about how it is written in RFC 6790.

I did talk to Kireeti briefly in the hallway about placement of ELI/EL and MS-PW.
He also did say the same but he also said that it does not matter where you place it,
as far as processing of the ELI/EL, would work irrespective.

MS-PW technology throws the monkey ranch.
One could just support 6790 and not 6391 for PW if ELI/EL placed below PW label.
It solves preservation of entropy across S-PE, nicely.

Thanks,
Himanshu

From: "Alexander com>" <[email-masked]>
Date: Tuesday, November 14, 2017 at 8:14 PM
To: "[email-masked]" <[email-masked]>, "Shah, Himanshu" <[email-masked]>
Subject: Re: [Pals] ELI/EL for the PW

Himamshu and all,
I respetfully disagree.

Thanks,
Himanshu

---

From: Shahram Davari <[email-masked]>
Date: Tue, 14 Nov 2017 17:37:48 -0800

Hi,

We have always assumed ELI/EL are above PW Label and are for LSPs only as per RFC 6790. This means the only method to provide PW Entropy is FAT late The only Label that can be below PW Label is PW FAT label.

I would recommend keeping it that way. Since we can’t change the RFC now.

Thx
Shahram

> On Nov 14, 2017, at 5:24 PM, Shah, Himanshu <[email-masked]> wrote:
> 
> Hi Shasha,
>  
> From: "Alexander com>" <[email-masked] <mailto:[email-masked]>>
> To: "[email-masked] <mailto:[email-masked]>" <[email-masked] <mailto:[email-masked]>>, "Shah, Himanshu" <[email-masked] <mailto:[email-masked]>>
> From: Pals <[email-masked] <mailto:[email-masked]>> on behalf of Shah, Himanshu <[email-masked] <mailto:[email-masked]>>
> To: [email-masked] <mailto:[email-masked]>
> FAT PW label would suffer the same misordering as no FAT PW label
> However, ELI/EL would NOT – because of the presence of ELI
>  
> Thanks,
> Himanshu
> 
> _______________________________________________
> Pals mailing list
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/pals <https://www.ietf.org/mailman/listinfo/pals>

---

From: Alexander Vainshtein <[email-masked]>
Date: Wed, 15 Nov 2017 05:48:15 +0000

Himanshu,
Of course EL/ELI can be placed anywhere in the stack. But it can only be inserted if the Egress LSR for the tunnel supports it. And in MS-PW each S-PE terminates the tunnel LSP.

>From my POV flow labels are the ONLY right mechanism for adding entropy to MS-PWs end-to-end.

________________________________
From: Shah, Himanshu <[email-masked]>
Sent: Wednesday, November 15, 2017 3:24:54 AM
To: Alexander Vainshtein; [email-masked]
Subject: Re: [Pals] ELI/EL for the PW

Hi Shasha,

Thanks,
Himanshu

Himamshu and all,
I respetfully disagree.

Thanks,
Himanshu

---

From: Alexander Vainshtein <[email-masked]>
Date: Wed, 15 Nov 2017 05:50:06 +0000

Shahram,
This is obw of a few times when yiu and I are in full agreement on an issue discussed on this list??

________________________________
From: Shahram Davari <[email-masked]>
Sent: Wednesday, November 15, 2017 3:37:48 AM
To: Shah, Himanshu
Cc: Alexander Vainshtein; [email-masked]
Subject: Re: [Pals] ELI/EL for the PW

Hi,

Thx
Shahram

On Nov 14, 2017, at 5:24 PM, Shah, Himanshu <[email-masked]<mailto:[email-masked]>> wrote:

Hi Shasha,

Thanks,
Himanshu

From: "Alexander com>" <[email-masked]<mailto:[email-masked]>>
Date: Tuesday, November 14, 2017 at 8:14 PM
To: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "Shah, Himanshu" <[email-masked]<mailto:[email-masked]>>
Subject: Re: [Pals] ELI/EL for the PW

Himamshu and all,
I respetfully disagree.

________________________________
From: Pals <[email-masked]<mailto:[email-masked]>> on behalf of Shah, Himanshu <[email-masked]<mailto:[email-masked]>>
Sent: Tuesday, November 14, 2017 5:30:13 AM
To: [email-masked]<mailto:[email-masked]>
Subject: [Pals] ELI/EL for the PW

Thanks,
Himanshu

_______________________________________________
Pals mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/pals

---

From: "Shah, Himanshu" <[email-masked]>
Date: Wed, 15 Nov 2017 06:14:53 +0000

Hi Sasha –

I understand that and I do not want to belabor my point.
So just to clarify my point, you can view MS-PW as “PW-LSP”
with S-PE as “PW-LSR”. In that context, ELI/EL below PW label,
makes sense.

FAT PW RFC predates the ELI/EL, but if that was not the case,
ELI/EL easily would have been used as the solution the way I describe above.

But that is all water under the bridge.
So, let us move on.

On the follow on topic on the guideline,
Where we say “when both are supported ONLY ONE (ELI/EL or FAT label) SHOULD be used”.

Since FAT label does not protect from ECMP based on DPI beyond PW CW, BOTH schemes are
required since FAT label suffers same mis-ordering consequences.
In addition, S-PE MUST preserve and/or regenerate ELI/EL above PW label,
If WG chose to provide guidelines on how to avoid mi-ordering in the presence of such switches.

Thanks,
Himanshu

From: "Alexander com>" <[email-masked]>
Date: Wednesday, November 15, 2017 at 1:48 PM
To: "[email-masked]" <[email-masked]>, "Shah, Himanshu" <[email-masked]>
Subject: Re: [Pals] ELI/EL for the PW

Himanshu,

Hi Shasha,

Thanks,
Himanshu

Himamshu and all,
I respetfully disagree.

Thanks,
Himanshu

---

From: Stewart Bryant <[email-masked]>
Date: Wed, 15 Nov 2017 08:06:56 +0000

Copying the thread to MPLS to include them in the discussion.

Please will copy future discussion to MPLS on this topic.

Thanks

Stewart

On 15/11/2017 06:14, Shah, Himanshu wrote:
> /Thanks,/
> /Himanshu/
> *From: *"Alexander com>" <[email-masked]>
> *Date: *Wednesday, November 15, 2017 at 1:48 PM
> *To: *"[email-masked]" <[email-masked]>, "Shah, Himanshu" <[email-masked]>
> *Subject: *Re: [Pals] ELI/EL for the PW
>
> Himanshu,
>
> Of course EL/ELI can be placed anywhere in the stack. But it can only 
> be inserted if the Egress LSR for the tunnel supports it. And in MS-PW 
> each S-PE terminates the tunnel LSP.
>
> ------------------------------------------------------------------------
>
> *From:*Shah, Himanshu <[email-masked]>
> *Sent:* Wednesday, November 15, 2017 3:24:54 AM
> *To:* Alexander Vainshtein; [email-masked]
> *Subject:* Re: [Pals] ELI/EL for the PW
>
> Hi Shasha,
>
> /Thanks,/
> /Himanshu/
> *From: *"Alexander com>" <[email-masked]>
> *Date: *Tuesday, November 14, 2017 at 8:14 PM
> *To: *"[email-masked]" <[email-masked]>, "Shah, Himanshu" <[email-masked]>
> *Subject: *Re: [Pals] ELI/EL for the PW
>
> Himamshu and all,
>
> I respetfully disagree.
>
> As I see it, RFC 6790 in Section 4.2 Ingress LSR" inambiguously states 
> that EL and ELI, if used, between thr TL and "application label" (if 
> spplication lsbel is used). It also specifies, that EL and ELI are 
> only pushed on an incoming packet if the tunnel egress LSR has 
> signaled that it can handle EL on the specific tunnel LSP it terminates.
>
> To me this means that in the case of a MS-PW, EL and ELI CANNOT 
> preserved by an S-PE. Whether they can be generated by an SPE is 
> another story.
>
> ------------------------------------------------------------------------
>
> *From:*Pals <[email-masked]> on behalf of Shah, Himanshu 
> <[email-masked]>
> *Sent:* Tuesday, November 14, 2017 5:30:13 AM
> *To:* [email-masked]
> *Subject:* [Pals] ELI/EL for the PW
>
> /The PALS WG discussions yesterday at the IETF100, we discussed the 
> competing/
>
> /FAT PW and ELI/EL for the PW and its fate at S-PE./
>
> //
>
> /I mentioned this at Mike but got lost in subsequent discussions./
>
> //
>
> /FAT PW label as well as ELI/EL for PW (based on microflow within PW) 
> resides/
>
> /below PW label. Thus, @ingress PE, once microflow is identified, 
> either ELI/EL/
>
> /or FAT PW label is pushed./
>
> //
>
> /@S-PE, PW label swap does not have to preserve the ELI/EL while doing 
> PW label swapping,/
>
> /BECAUSE it is already below the PW label, just like how FAT PW label 
> would be./
>
> //
>
> /I confirmed this from our data plane engineer./
>
> /(we can check with Kireeti as well)/
>
> //
>
> /I would like to know if other vendors are doing this differently??/
>
> //
>
> /Given this is true, for the switches that do DPI past PW control word 
> for ECMP, /
>
>   * /FAT PW label would suffer the same misordering as no FAT PW label/
>   * /However, ELI/EL would NOT – because of the presence of ELI/
>
> //
>
> /Thanks,/
>
> /Himanshu/
>
>
> [email-masked]

---

From: Shahram Davari <[email-masked]>
Date: Wed, 15 Nov 2017 14:53:53 -0800

Himanshu

We can’t consider the PW label as PW-LSP, even though there is a PW label swapping at S-PE.  At most you can consider it
as PW-LSP only at the S-PE but not at the Terminating PE.

We can’t do it is because we need to get packet processing context from PW label such as the Payload Type (IP, Ethernet, etc.), Existence of CW, and whether we are doing PHP or not, etc. If we assume PW-LSP then we can’t get any of these information from PW label.

So I really object to using ELI/EL below PW label.  Existing HW that complies to RFCs can’t support this.

Thx
Shahram

> On Nov 15, 2017, at 12:06 AM, Stewart Bryant <[email-masked]> wrote:
> 
>> From: "Alexander com>" <[email-masked]> <mailto:[email-masked]>
>> To: "[email-masked]" <mailto:[email-masked]> <[email-masked]> <mailto:[email-masked]>, "Shah, Himanshu" <[email-masked]> <mailto:[email-masked]>
>> From: Shah, Himanshu <[email-masked]> <mailto:[email-masked]>
>> To: Alexander Vainshtein; [email-masked] <mailto:[email-masked]>
>> From: "Alexander com>" <[email-masked]> <mailto:[email-masked]>
>> To: "[email-masked]" <mailto:[email-masked]> <[email-masked]> <mailto:[email-masked]>, "Shah, Himanshu" <[email-masked]> <mailto:[email-masked]>
>> From: Pals <[email-masked]> <mailto:[email-masked]> on behalf of Shah, Himanshu <[email-masked]> <mailto:[email-masked]>
> mpls mailing list
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/mpls <https://www.ietf.org/mailman/listinfo/mpls>

---

From: "Shah, Himanshu" <[email-masked]>
Date: Thu, 16 Nov 2017 04:08:05 +0000

Shahram –

You missed my point on “let’s move on”.
(BTW – justification you point out below for ELI/EL not equally eligible to identify flow as FAT label, for PW,
because of T-PE, is not valid – there is no PHP of PW label)

But really – let’s move on, because it is distracting from discussions on the other point I am making.

Thanks,
Himanshu

From: Pals <[email-masked]> on behalf of Shahram Davari <[email-masked]>
Date: Thursday, November 16, 2017 at 6:54 AM
To: Stewart Bryant <[email-masked]>
Cc: "[email-masked]" <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: Re: [Pals] [mpls] ELI/EL for the PW

Himanshu

Thx
Shahram

On Nov 15, 2017, at 12:06 AM, Stewart Bryant <[email-masked]<mailto:[email-masked]>> wrote:

Thanks,
Himanshu

From: "Alexander com>" <[email-masked]><mailto:[email-masked]>
Date: Wednesday, November 15, 2017 at 1:48 PM
To: "[email-masked]"<mailto:[email-masked]> <[email-masked]><mailto:[email-masked]>, "Shah, Himanshu" <[email-masked]><mailto:[email-masked]>
Subject: Re: [Pals] ELI/EL for the PW

Himanshu,

________________________________
From: Shah, Himanshu <[email-masked]><mailto:[email-masked]>
Sent: Wednesday, November 15, 2017 3:24:54 AM
To: Alexander Vainshtein; [email-masked]<mailto:[email-masked]>
Subject: Re: [Pals] ELI/EL for the PW

Hi Shasha,

Thanks,
Himanshu

From: "Alexander com>" <[email-masked]><mailto:[email-masked]>
Date: Tuesday, November 14, 2017 at 8:14 PM
To: "[email-masked]"<mailto:[email-masked]> <[email-masked]><mailto:[email-masked]>, "Shah, Himanshu" <[email-masked]><mailto:[email-masked]>
Subject: Re: [Pals] ELI/EL for the PW

Himamshu and all,
I respetfully disagree.

From: Pals <[email-masked]><mailto:[email-masked]> on behalf of Shah, Himanshu <[email-masked]><mailto:[email-masked]>

Thanks,
Himanshu

Pals mailing list

_______________________________________________
mpls mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/mpls